- Qt 5.15
- Qt 3D
- C++ Classes
- QSharedGLTexture
- Qt 5.15.11 Reference Documentation

# QSharedGLTexture Class

class Qt3DRender::QSharedGLTexture

Allows to use a textureId from a separate OpenGL context in a Qt 3D scene. More...

Header: | #include <Qt3DRender/QTexture>
qmake: | QT += 3drender
Since: | Qt 5.13
Instantiated By: | SharedGLTexture
Inherits: | Qt3DRender::QAbstractTexture

This class was introduced in Qt 5.13.

- List of all members, including inherited members

## Properties

- textureId : int

## Public Functions

int | textureId() const

## Public Slots

void | setTextureId(int id)

## Signals

void | textureIdChanged(int textureId)

## Detailed Description

Depending on the rendering mode used by Qt 3D, the shared context will either be:

- qt_gl_global_share_context when letting Qt 3D drive the rendering. When setting the attribute Qt::AA_ShareOpenGLContexts on the QApplication class, this will automatically make QOpenGLWidget instances have their context shared with qt_gl_global_share_context.
- the shared context from the QtQuick scene. You might have to subclass QWindow or use QtQuickRenderControl to have control over what that shared context is though as of 5.13 it is qt_gl_global_share_context.

Any 3rd party engine that shares its context with the Qt 3D renderer can now provide texture ids that will be referenced by the Qt 3D texture.

You can omit specifying the texture properties, Qt 3D will try at runtime to determine what they are. If you know them, you can of course provide them, avoid additional work for Qt 3D.

Keep in mind that if you are using custom materials and shaders, you need to specify the correct sampler type to be used.

## Property Documentation

### textureId : int

The OpenGL texture id value that you want Qt3D to gain access to.

Access functions:

int | textureId() const
void | setTextureId(int id)

Notifier signal:

void | textureIdChanged(int textureId)